/*-----------------------------------------------------------------------------
 *  TOPPERS/SSP Windows Debug Environment
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 *-----------------------------------------------------------------------------
 * $Id: target_support.c 107 2015-06-10 11:40:31Z coas-nagasima $
 */

/*
 *	^[QbgVXeˑW[iAP-RX62N-0Apj
 */

#include "kernel_impl.h"
#include <sil.h>

void hardware_init_hook()
{
	/*
	 * 샂[hݒ
	 *
	 * 샂[h̓{[h̒[qɂČ肳邽,
	 * ł͓ʐݒ肵Ȃ.
	 * , gGfBA/VO`bv[h
	 * ł邱ƂOƂ.
	 *
	 * ܂Zbg, ROMFL, RAMFL, OoXF
	 * ł.
	 */

	/*
	 * NbNݒ
	 *
	 * ́F12MHz
	 * PLLHF12 x 8 = 96MHz
	 * VXeNbNF96MHz
	 * ӃW[NbNF48MHz
	 * OoXNbNF96MHz
	 * Ƃ.
	 */
	sil_wrb_mem(PORT3_PDR_ADDR,
		sil_reb_mem(PORT3_PDR_ADDR) & ~PORT_PDR_B6_BIT);
	sil_wrb_mem(PORT3_PDR_ADDR,
		sil_reb_mem(PORT3_PDR_ADDR) & ~PORT_PDR_B7_BIT);
	sil_wrb_mem(PORT3_PMR_ADDR,
		sil_reb_mem(PORT3_PMR_ADDR) & ~PORT_PDR_B6_BIT);
	sil_wrb_mem(PORT3_PMR_ADDR,
		sil_reb_mem(PORT3_PMR_ADDR) & ~PORT_PDR_B7_BIT);

	sil_wrh_mem(SYSTEM_PRCR_ADDR, 0xa503);

	/* CNbNU틭U */
	while((sil_reb_mem(SYSTEM_MOFCR_ADDR) & SYSTEM_MOFCR_MOFXIN) == 0)
		sil_wrb_mem(SYSTEM_MOFCR_ADDR,
			sil_reb_mem(SYSTEM_MOFCR_ADDR) | SYSTEM_MOFCR_MOFXIN);

	/* CNbNU퓮 */
	while((sil_reb_mem(SYSTEM_MOSCCR_ADDR) & SYSTEM_MOSCCR_MOSTP) != 0)
		sil_wrb_mem(SYSTEM_MOSCCR_ADDR,
			sil_reb_mem(SYSTEM_MOSCCR_ADDR) & ~SYSTEM_MOSCCR_MOSTP);

	sil_wrh_mem(SYSTEM_PLLCR_ADDR,
		(sil_reh_mem(SYSTEM_PLLCR_ADDR) & ~SYSTEM_PLLCR_STC_MASK)
		| (0x0f << SYSTEM_PLLCR_STC_OFFSET));

	sil_wrb_mem(SYSTEM_PLLCR2_ADDR,
		sil_reb_mem(SYSTEM_PLLCR2_ADDR) & ~SYSTEM_PLLCR2_PLLEN);

	sil_wrw_mem(SYSTEM_SCKCR_ADDR, 0x21021211);

	/* PLLHI */
	sil_wrh_mem(SYSTEM_SCKCR3_ADDR,
		(sil_reh_mem(SYSTEM_SCKCR3_ADDR) & ~SYSTEM_SCKCR3_CKSEL_MASK)
		| (4 << SYSTEM_SCKCR3_CKSEL_OFFSET));

	/*
	 * W[Xgbv
	 *
	 * Zbg, 삵ĂӃW[DMAC, DTC,
	 * RAM݂̂ł.
	 * ȊO̓ӃW[ɊւĂ͎gp鑤
	 * ݒ肷邱.
	 */
	sil_wrh_mem(SYSTEM_PRCR_ADDR, 0xa500);
}

void software_init_hook()
{
	/*
	 * {RpCłweak definition̋@\,
	 * ɕKvȏ͂Ȃ, KĂяoƂƂ.
	 */
}
