/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2015 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: websocket.h 107 2015-06-10 11:40:31Z coas-nagasima $
 */

#ifndef WEBSOCKET_H
#define WEBSOCKET_H

#include "echonet_fbs.h"

typedef struct ws_state
{
	int state;
	int fin;
	enum opecode_t
	{
		continuation_frame = 0,
		text_frame = 1,
		binary_frame = 2,
		connection_close = 8,
		ping = 9,
		pong = 10
	} opecode;
	int payload_len;
	int masked;
	char masking_key[4];
	int data_pos;
} ws_state_t;

struct websocket
{
	ID wbsid;
	ws_state_t wstate;
	ws_state_t rstate;
	ECN_FBS_ID cur_in_msg;
};

void websocket_init(struct websocket *ws, ID wbsid);
void websocket_destroy(struct websocket *ws);
struct websocket *websocket_getws(ID wbsid);

int websocket_input(struct websocket *ws, const void *data, int len);
bool_t websocket_newdata(struct websocket *ws);
int websocket_output(struct websocket *ws, void *data, int len);

#endif  /* WEBSOCKET_H */
