/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: if_rx62n.h 107 2015-06-10 11:40:31Z coas-nagasima $
 */

/*
 * Copyright (C) 1993, David Greenman. This software may be used, modified,
 *   copied, distributed, and sold, in both source and binary form provided
 *   that the above copyright and these terms are retained. Under no
 *   circumstances is the author responsible for the proper functioning
 *   of this software, nor does the author assume any responsibility
 *   for damages incurred with its use.
 */

#ifndef _IF_RX62N_H_
#define _IF_RX62N_H_

/*
 *  tB[h
 */

#define ETHER_ADDR_LEN		6	/* Ethernet (MAC) Address	*/

/*
 *  RX62N Ethernet Controler Ɋւ`
 */

#define NUM_IF_RX62N_TXBUF		8	/* Mobt@			*/
#define NUM_IF_RX62N_RXBUF		8	/* Mobt@			*/
#define IF_RX62N_BUF_PAGE_SIZE	1518	/* obt@TCY */

/*
 *  NIC ̑I}N
 */

#define IF_ETHER_NIC_GET_SOFTC()	rx62n_get_softc()
#define IF_ETHER_NIC_WATCHDOG(i)	rx62n_watchdog(i)
#define IF_ETHER_NIC_PROBE(i)		rx62n_probe(i)
#define IF_ETHER_NIC_INIT(i)		rx62n_init(i)
#define IF_ETHER_NIC_LINK(i)		rx62n_link(i)
#define IF_ETHER_NIC_READ(i,b)		rx62n_read(i,b)
#define IF_ETHER_NIC_RESET(i)		rx62n_reset(i)
#define IF_ETHER_NIC_START(i,o,l)	rx62n_start(i,o,l)

#define T_IF_ETHER_NIC_SOFTC		struct t_rx62n_softc
struct t_if_softc {
	//T_IF_ADDR		ifaddr;			/* lbg[NC^tF[X̃AhX	*/
	//uint16_t		timer;			/* M^CAEg			*/
	T_IF_ETHER_NIC_SOFTC	*sc;	/* fBoCXˑ̃\tgEFA	*/
	uint8_t rxb_write;
	uint8_t rxb_read;
	bool_t link_pre;
	bool_t link_now;
	bool_t over_flow;
	int udp_pos;
};

/* IPv6 ֌W */

#define IF_ETHER_NIC_IN6_IFID(i,a)	get_mac6_ifid(i,a)	/* C^tF[Xʎq̐ݒ		*/
#define IF_ETHER_NIC_ADDMULTI(s)	rx62n_addmulti(s)		/* }`LXgAhX̓o^		*/

#if !defined(TOPPERS_MACRO_ONLY) && !defined(_MACRO_ONLY)

/*
 *  OQ
 */

#ifndef T_IF_SOFTC_DEFINED

typedef struct t_if_softc T_IF_SOFTC;

#define T_IF_SOFTC_DEFINED

#endif	/* of #ifndef T_IF_SOFTC_DEFINED */

/*
 *  ֐
 */

extern T_IF_SOFTC *rx62n_get_softc(void);
extern void rx62n_watchdog(T_IF_SOFTC *ic);
extern void rx62n_probe(T_IF_SOFTC *ic);
extern void rx62n_init(T_IF_SOFTC *ic);
extern void rx62n_reset(T_IF_SOFTC *ic);
extern bool_t rx62n_link(T_IF_SOFTC *ic);
extern int rx62n_read(T_IF_SOFTC *ic, void **input);
extern void rx62n_start(T_IF_SOFTC *ic, void *output, int size);
extern ER rx62n_addmulti(T_IF_SOFTC *ic);
extern void if_rx62n_trx_handler(void);

#endif /* #if !defined(TOPPERS_MACRO_ONLY) && !defined(_MACRO_ONLY) */

#endif	/* of #ifndef _IF_RX62N_H_ */
