/*
 *  TOPPERS ECHONET Lite Communication Middleware
 * 
 *  Copyright (C) 2014 Cores Co., Ltd. Japan
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: arduino.h 107 2015-06-10 11:40:31Z coas-nagasima $
 */

#ifndef _ARDUINO_H_
#define _ARDUINO_H_

typedef enum arduino_pin_mode
{
	ARDUINO_PIN_MODE_INPUT = 1,
	ARDUINO_PIN_MODE_OUTPUT,
	ARDUINO_PIN_MODE_INPUT_PULLUP,
} arduino_pin_mode_t;

typedef enum arduino_digital_value
{
	ARDUINO_DIGITAL_VALUE_HIGH = 1,
	ARDUINO_DIGITAL_VALUE_LOW,
} arduino_digital_value_t;

/*  */
void arduino_init();

/* fW^o͊֐  */
ER arduino_pinMode(int pin, arduino_pin_mode_t mode);
ER arduino_digitalWrite(int pin, arduino_digital_value_t value);
ER arduino_digitalRead(int pin, arduino_digital_value_t *result);

/* AiOo͊֐ */
ER arduino_analogRead(int pin, int *result);
ER arduino_analogWrite(int pin, int value);

/*  */
void arduino_tick();

#endif	/* of #ifndef _ARDUINO_H_ */
